/***************************************************************************/
// Copyright (c) 1996 by Matthias Schonlau
/***************************************************************************/

#include "general.h"

#ifndef _ALLOC_
#define _ALLOC_

/*********************************/
/* memory allocation and freeing */
/*********************************/
void alloc(int m, int n,real   ***mat);
void alloc(int m, int n,int    ***mat);
void alloc(int m, int n,string ***mat);
void alloc(int m, int n,char   ***mat);
void alloc(int n,real  **vec);   
void alloc(int n,int   **vec);
void alloc(int n,char  **vec);
void alloc(int n,string **vec);

void frei(int n,real **v); 
void frei(int n,int **v);
void frei(int n,string **vec);
void frei(int m,int n,string ***mat);
void frei(int m,int n,char ***mat);
void frei(int m, int n, int ***M);
void frei(int m, int n, real ***M);
void frei(int n,char **vec);

void morealloc(int oldn, real **vec, int newn);
void morealloc(int oldn, int **vec, int newn);
void morealloc(int oldn, string **vec, int newn);
void morealloc(int oldm, int oldn, real ***M, int newm, int newn);
void morealloc(int oldm, int oldn, int ***M, int newm, int newn);
void morealloc(int oldm, int oldn, string ***M, int newm, int newn);

real *generic_alloc(int oldn,real *vec,int newn);
void add_list(boolean add,int n,real *vec);
int seek_list(int n,real *ptr);
void print_list(char *comment);

real **generic_alloc(int oldn,real **vec,int newn);
void add_list(boolean add,int n,real **vec);
int seek_list(int n,real **ptr);
void print_dlist(char *comment);

int *generic_alloc(int oldn,int *vec,int newn);
void add_list(boolean add,int n,int *vec);
int seek_list(int n,int *ptr);
void print_int_list(char *comment);

int **generic_alloc(int oldn,int **vec,int newn);
void add_list(boolean add,int n,int **vec);
int seek_list(int n,int **ptr);
void print_int_dlist(char *comment);

void check_alloc(real *v, int i,char label[]="");
void check_alloc(real **M, int i,int j, char label[]="");
void check_alloc(int *v, int i,char label[]="");
void check_alloc(int **M, int i,int j, char label[]="");

#endif
