/***************************/
/* Order algorithm functions */
/***************************/

#ifndef  _ORDER_
#define  _ORDER_
#endif

struct node
{
  int key;
  real prob;
  node *down;
};

/***************************/
/* krigorder.cc  file	   */
/***************************/
void update_kid_nodes(node *anode,int depth);
node *tree(node *anode);
void firstcall_info();
int diagnostics(real lower, real upper, boolean univ_gr_alpha);
int increase_N();
void print_tree(node anode, int tree_depth);
void free_tree(node anode);
real calc_prob(int *varindex, real prob);
void alloc_tree(int old_n,node **thisnode,int new_n);
boolean Reduction1b(int newkey);
boolean tiny_prob(node start_node, int imax,int *apattern);
void print_totalnodes(int len_vec,int *total_nodes,int univ_count,
  boolean univ_gr_alpha);

/***************************/
/* cdfmnmc.cc and cdfmndh.cc file */
/***************************/
real mncdf(int n, real **t, real *h);
real mncdfmc(int n, real **t, real *h);

/***************************/
/* treealloc.cc  file	   */
/***************************/
int find_tlist(node *vec);
int seek_tlist(int n,node *vec);
void add_tlist(boolean add,int n,node *vec);
node *generic_tree_alloc(int oldn,node *vec,int newn);
void print_tlist(char *comment="  ");
void frei_tlist(char *comment="");

