#include <sys/types.h> // for fork
#include <unistd.h>   // for execlp and getpid
#include <sys/wait.h> // for wait 
#include <stdio.h>

#ifndef general
#include "general.h"
#endif

extern FILE *ofp;

//#include <stdlib.h>
//#include <iostream.h>
//#include "general.h"
//int  speed= 1; 

/************************************************************************/
/* Version : July 15, 96- May 05, 97					*/
/* Purpose : execute the command "(FuncName) space.temp" at system level  */ 
/*           and continue the program after that execution		*/
/* Note    : no error checking is done, no buffers are flushed first    */  
void exec_system(char FuncName[MAXLINE])
{
   int status;
   char command[MAXLINE];

   //cout << "*" << FuncName << "*\n";
   if (fork() == 0 )
   {
     // execlp(FuncName,FuncName, "space.temp", (char *) 0); // child
     sprintf(command,"`%s`",FuncName);
     execlp("sh","sh","-c",command,(char *) 0); // child
     // child only returns in case of error
     nrerror("exec_system: Likely reasons: \n\t (1) Minimization function does not exist (in specified directory) \n\t (2) 2 space processes running simultaneously accessing space.temp");
   }
   wait(&status); //parent 
}
/************************************************************************/
/* Version : April 01, 1996                                             */
/* Purpose : calculate cpu time (user + system)  spend between two 	*/
/*	     function calls: 						*/
/*   	     start: cputime(1) 		end: cputime(2)                 */
/*   	     temp start: cputime(11) 	temp end: cputime(12)           */
/* CAUTION : accuracy of this is limited to my_CLK_TCK,                 */
/*which on this machine is 60.0 . I am using my own my_CLK_TCK, because */
/*the function gives wrong values with the CLK_TCK macro from c library */
/* CAUTION : times (as needed ) is very different from time             */

#include <sys/types.h>    /* needed for clock_t */
#include <sys/times.h>    /* needed for clock_t */

#define my_CLK_TCK 60.0

void  cputime(int ruf, char text[])
{
struct tms tms;
static double cpu_end, cpu_start, temp_end, temp_start, temp2_end, temp2_start; 

 if ((clock_t)-1 == times(&tms))
   nrerror("cputime: times function gives error \n ");
 if (ruf==1)
   cpu_start= (tms.tms_utime + tms.tms_stime)/(double) my_CLK_TCK;
 else if (ruf==2)
 {
   cpu_end = (tms.tms_utime + tms.tms_stime)/ (double) my_CLK_TCK;
   fprintf(ofp,"%s Seconds: %.1f  \n ", text,cpu_end-cpu_start);
 }
 else if (ruf==11)
   temp_start= (tms.tms_utime + tms.tms_stime)/(double) my_CLK_TCK;
 else if (ruf==12)
 {
   temp_end = (tms.tms_utime + tms.tms_stime)/ (double) my_CLK_TCK;
   fprintf(ofp,"%s Seconds: %.1f\n", text,temp_end-temp_start);
 }
 else if (ruf==21)
   temp2_start= (tms.tms_utime + tms.tms_stime)/(double) my_CLK_TCK;
 else if (ruf==22)
 {
   temp2_end = (tms.tms_utime + tms.tms_stime)/ (double) my_CLK_TCK;
   //fprintf(ofp,"%s Seconds: %.1f\n", text,temp2_end-temp2_start);
   fprintf(ofp,"%s Seconds: %.3f\n", text,temp2_end-temp2_start);
 }
 else
   nrerror("cputime : unknown argument");
}
/************************************************************************/
/*
void main()
{
  real sample_new_y(char FuncName[MAXLINE],int d,real *xbest);
  int i,d=2;
  real *xbest;
  char FuncName[MAXLINE] = "./braninfun";

  alloc(2,&xbest);
  xbest[0] = 2.0;
  xbest[1] = 3.3;

  cout << "leaving.. \n";
  sample_new_y(FuncName,d,xbest);  need to include
  cout << "welcome back \n ";
  cputime(1);
  cputime(11);
  for (i=0;i< 10e5; i++);
  cputime(12);
  for (i=0;i< 10e5; i++);
  cputime(2);
}
*/
